#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two21004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 2100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two21004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two21004xi

#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 2100
# -------------------------------------------------------------------------------------------------
shot2two21004xi = {
        1:'1011x-1822y-253z',
        2:'1081x-1799y-19z',
        3:'1104x-1765y-274z',
        4:'1174x-1740y-40z',
        5:'1193x-1702y-295z',
        6:'1263x-1676y-61z',
        7:'1279x-1635y-315z',
        8:'127x-865y-1909z',
        9:'1348x-1607y-82z',
        10:'1360x-1563y-336z',
        11:'140x-1091y-1788z',
        12:'1430x-1533y-103z',
        13:'1438x-1487y-357z',
        14:'1507x-1456y-124z',
        15:'150x-1357y-1595z',
        16:'1511x-1407y-378z',
        17:'1580x-1324y-398z',
        18:'1581x-1374y-145z',
        19:'1644x-1237y-419z',
        20:'1649x-1288y-166z',
        21:'168x-838y-1917z',
        22:'1702x-1147y-439z',
        23:'1713x-1199y-187z',
        24:'1756x-1054y-460z',
        25:'1772x-1107y-208z',
        26:'1805x-958y-480z',
        27:'1825x-1012y-229z',
        28:'183x-2090y-86z',
        29:'1848x-860y-501z',
        30:'1874x-914y-250z',
        31:'1886x-761y-521z',
        32:'1916x-813y-270z',
        33:'1918x-659y-541z',
        34:'1945x-556y-562z',
        35:'194x-1064y-1799z',
        36:'1954x-711y-291z',
        37:'1966x-452y-582z',
        38:'1981x-348y-602z',
        39:'1985x-607y-312z',
        40:'1990x-243y-622z',
        41:'1992x-33y-662z',
        42:'1994x-138y-642z',
        43:'2011x-501y-333z',
        44:'2028x-543y-5z',
        45:'2031x-394y-353z',
        46:'2046x-287y-374z',
        47:'2053x-436y-26z',
        48:'2054x-179y-395z',
        49:'2057x-71y-415z',
        50:'2073x-328y-47z',
        51:'207x-810y-1926z',
        52:'2087x-219y-68z',
        53:'2095x-109y-89z',
        54:'218x-1331y-1608z',
        55:'245x-1035y-1810z',
        56:'255x-817y-2026z',
        57:'26x-1135y-1766z',
        58:'284x-1302y-1622z',
        59:'292x-2076y-107z',
        60:'294x-1003y-1820z',
        61:'340x-969y-1831z',
        62:'348x-1270y-1635z',
        63:'37x-912y-1891z',
        64:'383x-933y-1841z',
        65:'401x-2057y-128z',
        66:'409x-1234y-1648z',
        67:'424x-895y-1851z',
        68:'461x-855y-1861z',
        69:'467x-1196y-1661z',
        70:'496x-814y-1870z',
        71:'507x-2032y-149z',
        72:'522x-1154y-1674z',
        73:'527x-772y-1880z',
        74:'555x-728y-1889z',
        75:'574x-1111y-1686z',
        76:'580x-683y-1898z',
        77:'582x-16y-2017z',
        78:'601x-49y-2011z',
        79:'602x-638y-1907z',
        80:'613x-2001y-170z',
        81:'617x-83y-2005z',
        82:'621x-593y-1916z',
        83:'623x-1064y-1699z',
        84:'632x-119y-1998z',
        85:'637x-547y-1924z',
        86:'644x-156y-1992z',
        87:'649x-501y-1933z',
        88:'654x-195y-1985z',
        89:'658x-455y-1941z',
        90:'662x-236y-1978z',
        91:'665x-410y-1949z',
        92:'667x-278y-1971z',
        93:'668x-1016y-1711z',
        94:'668x-365y-1956z',
        95:'669x-321y-1964z',
        96:'710x-966y-1723z',
        97:'716x-1964y-190z',
        98:'749x-914y-1735z',
        99:'74x-2097y-65z',
        100:'784x-861y-1747z',
        101:'80x-1379y-1581z',
        102:'815x-806y-1758z',
        103:'817x-1922y-211z',
        104:'83x-890y-1900z',
        105:'843x-751y-1770z',
        106:'84x-1114y-1777z',
        107:'868x-694y-1781z',
        108:'888x-637y-1792z',
        109:'889x-41y-1901z',
        110:'8x-1397y-1567z',
        111:'905x-580y-1803z',
        112:'905x-89y-1892z',
        113:'915x-1875y-232z',
        114:'917x-139y-1883z',
        115:'919x-523y-1814z',
        116:'927x-191y-1874z',
        117:'929x-466y-1824z',
        118:'934x-244y-1864z',
        119:'935x-410y-1834z',
        120:'938x-298y-1854z',
        121:'938x-354y-1844z'}
        
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2100two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2100two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2100TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2100TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2100TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2100TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2100TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two21004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2100TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2100TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2100TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two21004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two21004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2100TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2100TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2100TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two21004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        